
freeslot(
	"SPR_MWCF",
	"S_SMWCAPE_IDLE",
	"S_SMWCAPE_MOVE",
	"S_SMWCAPE_STOP",
	"S_SMWCAPE_FALL",
	"S_SMWCAPE_BACK",
	"MT_SMW_CFCAPE"
)

states[S_SMWCAPE_IDLE] = {
    sprite = SPR_MWCF,
    frame = A,
    tics = -1,
    nextstate = S_SMWCAPE_IDLE
}

states[S_SMWCAPE_MOVE] = {
    sprite = SPR_MWCF,
    frame = B|FF_ANIMATE,
    tics = -1,
    nextstate = S_SMWCAPE_MOVE,
	var1 = 3,
	var2 = 32
}

states[S_SMWCAPE_STOP] = {
    sprite = SPR_MWCF,
    frame = F|FF_ANIMATE,
    tics = 2*3,
    nextstate = S_SMWCAPE_IDLE,
	var1 = 1,
	var2 = 3
}

states[S_SMWCAPE_FALL] = {
    sprite = SPR_MWCF,
    frame = H|FF_ANIMATE,
    tics = -1,
    nextstate = S_SMWCAPE_FALL,
	var1 = 3,
	var2 = 3
}

states[S_SMWCAPE_BACK] = {
    sprite = SPR_MWCF,
    frame = L,
    tics = -1,
    nextstate = S_SMWCAPE_BACK
}

mobjinfo[MT_SMW_CFCAPE] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_SMWCAPE_IDLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi" return end
	
	if p.smwpowerup == 3
	and not (p.smwcfcape and p.smwcfcape.valid)
		p.smwcfcape = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMW_CFCAPE)
		local cape = p.smwcfcape
		cape.target = p.mo
	end
end)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	
	local pmo = mo.target
	local p = pmo.player
	
	if p.smwpowerup ~= 3 P_RemoveMobj(mo) return end
	
	P_MoveOrigin(mo, pmo.x, pmo.y, pmo.z)
	mo.angle = p.drawangle
	mo.spritexscale = FixedMul(pmo.spritexscale, skins[pmo.skin].highresscale)
	mo.spriteyscale = FixedMul(pmo.spriteyscale, skins[pmo.skin].highresscale)
	mo.scale = pmo.scale
	mo.dispoffset = -1
	
	if p.smwpbaloon
	or pmo.state == S_SMW_VICTORY
	or pmo.state == S_SMW_CFSPIN
		local state = S_SMWCAPE_BACK
		if pmo.state == S_SMW_CFSPIN
			state = S_SMWCAPE_MOVE
		end
		if mo.state ~= state
			mo.state = state
		end
	else
		if P_IsObjectOnGround(pmo)
			if p.speed > 0
			and mo.state ~= S_SMWCAPE_MOVE
				mo.state = S_SMWCAPE_MOVE
			elseif p.speed == 0
			and mo.state ~= S_SMWCAPE_STOP
				local state = S_SMWCAPE_IDLE
				if mo.state == S_SMWCAPE_MOVE
				or mo.state == S_SMWCAPE_FALL
					state = S_SMWCAPE_STOP
				end
				mo.state = state
			end
		else
			if pmo.state ~= S_SMW_RUNNINGJUMP
				if (pmo.momz > 0 and not (pmo.eflags & MFE_VERTICALFLIP))
				or (pmo.momz < 0 and (pmo.eflags & MFE_VERTICALFLIP))
					local state = S_SMWCAPE_IDLE
					if (pmo.eflags & MFE_UNDERWATER)
						state = S_SMWCAPE_MOVE
					end
					if mo.state ~= state
						mo.state = state
					end
				elseif not ((pmo.momz > 0 and not (pmo.eflags & MFE_VERTICALFLIP)) or (pmo.momz < 0 and (pmo.eflags & MFE_VERTICALFLIP)))
				and mo.state ~= S_SMWCAPE_FALL
					mo.state = S_SMWCAPE_FALL
				end
			elseif mo.state ~= S_SMWCAPE_MOVE
				mo.state = S_SMWCAPE_MOVE
			end
		end
	end
	
	local easey = ease.linear(FixedDiv(p.speed, 36*FU), 4*FU, 2*FU)
	
	if mo.state == S_SMWCAPE_MOVE
	--and P_IsObjectOnGround(pmo)
	and mo.anim_duration >= 32
		mo.anim_duration = max(2, easey/FU)
	end
	
	if mo.state == S_SMWCAPE_FALL
		if p.smwcrouch
			mo.spriteyoffset = -5*FU
			mo.spritexoffset = 3*FU
		else
			mo.spriteyoffset = 0
			mo.spritexoffset = 0
		end
	else
		mo.spriteyoffset = 0
		mo.spritexoffset = 0
	end
end, MT_SMW_CFCAPE)